﻿using System;
using System.Collections;
using System.Linq;
using System.Text;

namespace Tateyomi_Support
{
    class Complement
    {
        private String[] defaultTateyomi = { "ネコだいすき",
                                               "長門は俺の嫁"};
        private String[] defaultSource = { "ネタガノグラフィという造語に感動。自動化を考えてみたが、コレを実現するには、文中に文字が揃っている必要がある。欠けた部分を検出することで、縦読み生成支援、ぐらいのものはできるかも知れない。",
                                             "長い夢から覚めた気分だ・・・俺は気がつくとここにいた。門の前には2つの人影がある・・・１人は若い男だ。はっとした。見間違いだと思った・・・あの・・・もう１人の人物・・・。俺は信じがたい光景を目の当たりにして少々混乱した。のんきに生きてきた自分を初めて呪った・・・。嫁だ・・・これは・・・嫁の浮気現場だったのだ・・・俺は神を憎み、絶望した・・・ 。" };
        private Hashtable recommend = new Hashtable();

        /// <summary>
        /// デフォルトのコンストラクタをオーバーライドしています。
        /// 　・推奨文字列の連想配列reccomendを初期化します。
        /// </summary>
        public Complement()
        {
            //推奨文字列の連想配列recommendを初期化します。
            recommend.Add("あ", "あんたあの娘のなんなのさ。");
            recommend.Add("だ", "だまれ小僧！　お前にサンが救えるか！");
        }

        /// <summary>
        /// 縦読み文字列の初期値を返します。
        /// </summary>
        /// <param name="index">(int)初期値の格納されている配列のindex<br/>
        /// getDefaultSource(int index)と使用するindexは共通にしてください。</param>
        /// <returns>縦読み文字列</returns>
        public String getDefaultTateyomi(int index)
        {
            return defaultTateyomi[index];
        }

        /// <summary>
        /// 文章の初期値を返します。
        /// </summary>
        /// <param name="index">(int)初期値の格納されている配列のindex<br/>
        /// getDefaultTateyomi(int index)と使用するindexは共通にしてください。</param>
        /// <returns></returns>
        public String getDefaultSource(int index)
        {
            return defaultSource[index];
        }

        /// <summary>
        /// 推奨文字列を返します。役に立つ保証はしません。
        /// </summary>
        /// <param name="key">連想配列のキー</param>
        /// <returns>推奨文字列（キーに合致する値がない場合は、nullを返します）</returns>
        public String getRecommend(String key)
        {
            return (String)recommend[key];
        }
    }
}
